﻿// -----------------------------------------------------------------------
// <copyright file="TSTTest.cs" company=".">
// 
// </copyright>
// -----------------------------------------------------------------------

namespace mockupCirene.Model.TestModel
{
    using System.Text;

    /// <summary>
    /// A class that gives a description of a test, device currently used and a few other properties.
    /// </summary>
    public class Step : TSTTest
    {
        /// <summary>
        /// Property that gets and sets test description.
        /// </summary>
        public override string Description
        {
            get
            {
                return base.Description;
            }
            set
            {
                base.Description = value;
                RaisePropertyChanged("_description");
            }
        }
        string _device = "SelPrior";

        /// <summary>
        /// Implements get and set method of device.
        /// </summary>
        public string Device
        {
            get { return _device; }
            set
            {
                _device = value;
                RaisePropertyChanged("Device");
            }
        }

        string _command;

        /// <summary>
        /// Property for test command getting and setting.
        /// </summary>
        public string Command
        {
            get { return _command; }
            set
            {
                _command = value;
                RaisePropertyChanged("Command");
            }
        }

        string _value;

        /// <summary>
        /// Gets and sets value.
        /// </summary>
        public string Value
        {
            get { return _value; }
            set
            {
                _value = value;
                RaisePropertyChanged("Value");
            }
        }

        int _delay;

        /// <summary>
        /// Gets and sets delay.
        /// </summary>
        public int Delay
        {
            get { return _delay; }
            set
            {
                _delay = value;
                RaisePropertyChanged("Delay");
            }
        }

        string _option = "[SET]";

        /// <summary>
        /// Gets and sets option.
        /// </summary>
        public string Option
        {
            get { return _option; }
            set
            {
                _option = value;
                RaisePropertyChanged("Option");
            }
        }

        /// <summary>
        /// Overridden ToString method.
        /// </summary>
        public override string ToString()
        {
            StringBuilder output = new StringBuilder();
            output.AppendFormat("[step]\n");
            output.AppendFormat("description = {0}\n", Description);
            output.AppendFormat("device = {0}\n", Device);
            output.AppendFormat("command = {0}\n", Command);
            output.AppendFormat("value = {0}\n", Value);
            output.AppendFormat("delay = {0}\n", Delay);
            output.AppendFormat("option = {0}\n", Option);
            output.AppendLine("");
            var dd = output.ToString();
            return dd;
        }

    }
}
