﻿namespace mockupCirene.Model.TestModel
{
    using System.Text;


    /// <summary>
    /// This class holds basic properties of a test, overriding property with description and ToString method from TestStepBase class. 
    /// </summary>
    public class TSTTest : TestStepBase
    {
        int _ID;

        /// <summary>
        /// Property that gets and sets test ID.
        /// </summary>
        public int ID
        {
            get { return _ID; }

            set
            {
                _ID = value;
                RaisePropertyChanged("ID");
            }
        }

        string _name;

        /// <summary>
        /// Property that gets and sets method name.
        /// </summary>
        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                RaisePropertyChanged("Name");
            }
        }

        /// <summary>
        /// Overridden property that gets and sets test description.
        /// </summary>
        public override string Description
        {
            get
            {
                return base.Description;
            }
            set
            {
                base.Description = value;
                RaisePropertyChanged("_description");
            }
        }

        string _log_file;

        /// <summary>
        /// Property that gets and sets log file.
        /// </summary>
        public string Log_file
        {
            get { return _log_file; }
            set
            {
                _log_file = value;
                RaisePropertyChanged("Log_file");
            }
        }

        /// <summary>
        /// Overridden ToString method.
        /// </summary>
        public override string ToString()
        {
            StringBuilder output = new StringBuilder();
            output.AppendFormat("[test]\n");
            output.AppendFormat("ID = {0}\n", ID);
            output.AppendFormat("name = {0}\n", Name);
            output.AppendFormat("description = {0}\n", Description);
            output.AppendFormat("log_file = {0}\n", Log_file);
            output.Append("\n");
            string dd = output.ToString();
            return dd;
        }
    }
}
