﻿namespace mockupCirene.Model.TestModel
{
    using mockupCirene.Helpers;


    /// <summary>
    /// This class gives a description of one step of the testing process.
    /// </summary>
    public abstract class TestStepBase : ObservableObject
    {
        string _description;

        /// <summary>
        /// Property that gets and sets test description.
        /// </summary>
        public virtual string Description
        {
            get { return _description; }
            set 
            { 
                _description = value;
                RaisePropertyChanged("_description");
            }
        }

        /// <summary>
        /// Overridden ToString method.
        /// </summary>
        public override string ToString()
        {
            return this.GetType().Name;
        }

    }
}
