﻿namespace mockupCirene.Model.Components
{
    using mockupCirene.Helpers;

    /// <summary>
    /// This class contains properties with testing results information.
    /// </summary>
    public class TestResult : ObservableObject
    {
        string _ID;

        /// <summary>
        /// Gets and sets the test ID.
        /// </summary>
        public string ID
        {
            get { return _ID; }
            set
            {
                _ID = value;
                RaisePropertyChanged("ID");
            }
        }

        string _date;

        /// <summary>
        /// Gets and sets the date of execution.
        /// </summary>
        public string Date
        {
            get { return _date; }
            set
            {
                _date = value;
                RaisePropertyChanged("Date");
            }
        }

        string _time;

        /// <summary>
        /// Gets and sets the time of execution.
        /// </summary>
        public string Time
        {
            get { return _time; }
            set
            {
                _time = value;
                RaisePropertyChanged("Time");
            }
        }


        string _project;

        /// <summary>
        /// Gets and sets the name of the current project.
        /// </summary>
        public string Project
        {
            get { return _project; }
            set
            {
                _project = value;
                RaisePropertyChanged("Project");
            }
        }
        private string _testCase;

        /// <summary>
        /// Gets and sets the test case name.
        /// </summary>
        public string TestCase
        {
            get { return _testCase; }
            set
            {
                _testCase = value;
                RaisePropertyChanged("TestCase");
            }
        }
        private string _result;

        /// <summary>
        /// Gets and sets the result of tests execution.
        /// </summary>
        public string Result
        {
            get { return _result; }
            set
            {
                _result = value;
                RaisePropertyChanged("Result");
            }
        }

        private string _build;

        /// <summary>
        /// Gets and sets the build status.
        /// </summary>
        public string Build
        {
            get { return _build; }
            set
            {
                _build = value;
                RaisePropertyChanged("Build");
            }
        }

        private string _tester;

        /// <summary>
        /// Gets and sets the name of the tester.
        /// </summary>
        public string Tester
        {
            get { return _tester; }
            set
            {
                _tester = value;
                RaisePropertyChanged("Tester");
            }
        }

        private string _comment;

        /// <summary>
        /// Gets and sets the comment.
        /// </summary>
        public string Comment
        {
            get { return _comment; }
            set
            {
                _comment = value;
                RaisePropertyChanged("Comment");
            }
        }

        private string _description;

        /// <summary>
        /// Gets and sets the test description.
        /// </summary>
        public string Description
        {
            get { return _description; }
            set
            {
                _description = value;
                RaisePropertyChanged("Description");
            }
        }
        private string _hw;

        /// <summary>
        /// Gets and sets the hardware ID.
        /// </summary>
        public string HW
        {
            get { return _hw; }
            set
            {
                _hw = value;
                RaisePropertyChanged("HW");
            }
        }
        private string _filePath;

        /// <summary>
        /// Gets and sets the file path.
        /// </summary>
        public string FilePath
        {
            get { return _filePath; }
            set
            {
                _filePath = value;
                RaisePropertyChanged("FilePath");
            }
        }
    }
}
