﻿// -----------------------------------------------------------------------
// <copyright file="InstrumentedMethod.cs" company=".">
// 
// </copyright>
// -----------------------------------------------------------------------

namespace mockupCirene.Model
{
    using mockupCirene.Helpers;

    /// <summary>
    /// With this data, related to test cases, method information is given.
    /// </summary>
    public class InstrumentedMethod : ObservableObject //, IEqualityComparer<InstrumentedMethod>
    {
        int _id;

        /// <summary>
        /// Gets and sets the test ID.
        /// </summary>
        public int ID
        {
            get { return _id; }
            set
            {
                _id = value;
                RaisePropertyChanged("ID");
            }
        }

        string _method;
        /// <summary>
        /// Gets and sets the method name.
        /// </summary>
        public string Method
        {
            get 
            { 
                if (string.IsNullOrEmpty(_method) )
                {
                    Method = "<unknown function>";                
                }
                return _method; 
            }
            set
            {
                _method = value;
                RaisePropertyChanged("Method");
            }
        }


        string _package;

        /// <summary>
        /// Gets and sets the package name.
        /// </summary>
        public string Package
        {
            get
            {
                if (string.IsNullOrEmpty(_package))
                {
                    Package = "<unknown function>";
                }
                return _package; 
            }
            set
            {
                _package = value;
                RaisePropertyChanged("Package");
            }
        }
    }
}
