﻿// -----------------------------------------------------------------------
// <copyright file="TestApplications.cs" company=".">
// 
// </copyright>
// -----------------------------------------------------------------------

namespace mockupCirene.Model
{
    using System.Collections.Generic;
    using System.Collections.ObjectModel;


    /// <summary>
    /// Holds all the needed data for test case execution.
    /// </summary>
    public class TestApplications : TestBase, IList<TestApplication>
    {        
        #region Test Cases

        ObservableCollection<TestApplication> _testcases;

        private ObservableCollection<TestApplication> InternalTestApplications
        {
            get 
            {
                if (_testcases == null) 
                {
                    InternalTestApplications = new ObservableCollection<TestApplication>();
                }
                return _testcases; 
            }
            set { _testcases = value; }
        }

        /// <summary>
        /// Searches for the index of the given item.
        /// </summary>
        /// <param name="item"></param>
        /// <returns>
        /// Returns the first occurance of the item.
        /// </returns>
        public int IndexOf(TestApplication item)
        {
            return InternalTestApplications.IndexOf(item);
        }

        /// <summary>
        /// Inserts an item at the specified index of the collection.
        /// </summary>
        /// <param name="index"></param>
        /// <param name="item"></param>
        public void Insert(int index, TestApplication item)
        {
            InternalTestApplications.Insert(index, item);
        }

        /// <summary>
        /// Removes an element at the specified position.
        /// </summary>
        /// <param name="index"></param>
        public void RemoveAt(int index)
        {
            InternalTestApplications.RemoveAt(index);

        }

        /// <summary>
        /// Obtains the test from the collection at the specified position.
        /// </summary>
        /// <param name="index"></param>
        /// <returns>
        /// Returns the test from the collection at the specified position.
        /// </returns>
        public TestApplication this[int index]
        {
            get
            {
                return InternalTestApplications[index];
            }
            set
            {
                InternalTestApplications[index] = value;
            }
        }
        /// <summary>
        /// Adds an object to end of the collection.
        /// </summary>
        /// <param name="item"></param>
        public void Add(TestApplication item)
        {
            InternalTestApplications.Add(item);
        }

        /// <summary>
        /// Removes all elements from the collection.
        /// </summary>
        public void Clear()
        {
            InternalTestApplications.Clear();
        }

        /// <summary>
        /// Determines whether an element is in the collection.
        /// </summary>
        /// <param name="item"></param>
        /// <returns>
        /// Returns true if the element is found in the collection.
        /// </returns>
        public bool Contains(TestApplication item)
        {
            return InternalTestApplications.Contains(item);
        }

        /// <summary>
        /// Copies the collection into an array.
        /// </summary>
        /// <param name="array"></param>
        /// <param name="arrayIndex"></param>
        public void CopyTo(TestApplication[] array, int arrayIndex)
        {
            InternalTestApplications.CopyTo(array, arrayIndex);
        }

        /// <summary>
        /// Gets the number of elements from the collection.
        /// </summary>
        public int Count
        {
            get { return InternalTestApplications.Count; }
        }

        /// <summary>
        /// Gets return value false if is read-only.
        /// </summary>
        public bool IsReadOnly
        {
            get { return false; }
        }

        /// <summary>
        /// Removes the specified item from the collection.
        /// </summary>
        /// <param name="item"></param>
        /// <returns>
        /// Returns true if the specified element has been removed.
        /// </returns>
        public bool Remove(TestApplication item)
        {
            return InternalTestApplications.Remove(item);
        }

        /// <summary>
        /// Obtains the enumerator that iterates through the collection.
        /// </summary>
        /// <returns>
        /// Returns that enumerator.
        /// </returns>
        public IEnumerator<TestApplication> GetEnumerator()
        {
            return InternalTestApplications.GetEnumerator();
        }

        /// <summary>
        /// Obtains the enumerator that iterates through the collection of interface.
        /// </summary>
        /// <returns>
        /// Returns the current iterator of the collection.
        /// </returns>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return InternalTestApplications.GetEnumerator();
        }
        #endregion
    }
}
