﻿// -----------------------------------------------------------------------
// <copyright file="TestCoverage.cs" company=".">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace mockupCirene.Model
{
    using System;
    using System.Collections.Generic;
    using System.Collections.ObjectModel;
    using System.Linq;
    using System.Text;
    using mockupCirene.Helpers;
    using mockupCirene.Model.TestModel;
    using mockupCirene.Model.Components;
    using System.IO;//File

    /// <summary>
    /// All data about test is in here
    /// </summary>
    /// 
    public class TestCoverage : ObservableObject
    {
        ITestPlan _test;

        public ITestPlan Test
        {
            get
            {
                if (_test == null)
                {
                    Test = new SelectionPrioritizationConfigAndRunTST();
                }
                return _test;
            }
            set { _test = value; }
        }


        #region properties
        LogLevel _testLogLevel;

        public LogLevel TestLogLevel
        {
            get { return _testLogLevel; }
            set
            {
                _testLogLevel = value;
                RaisePropertyChanged("TestLogLevel");
            }
        }

        public IEnumerable<LogLevel> LogLevels
        {
            get { return Enum.GetValues(typeof(LogLevel)).Cast<LogLevel>(); }
        }

        string _logLocation;

        public string LogLocation
        {
            get
            {
                return _logLocation;
            }
            set
            {
                _logLocation = value;
                RaisePropertyChanged("LogLocation");
            }
        }

        string _resultLocation;

        public string ResultLocation
        {
            get
            {
                return _resultLocation;
            }
            set
            {
                _resultLocation = value;
                RaisePropertyChanged("ResultLocation");
            }
        }

        string _baseLocation;

        public string BaseLocation
        {
            get { return _baseLocation; }
            set
            {
                _baseLocation = value;
                RaisePropertyChanged("BaseLocation");
            }
        }

        string _methodsLocation;

        public string MethodsLocation
        {
            get { return _methodsLocation; }
            set
            {
                _methodsLocation = value;
                RaisePropertyChanged("MethodsLocation");
            }
        }
        IPAddress _hostAddress;

        public IPAddress HostAddress
        {
            get
            {
                if (_hostAddress == null)
                {
                    HostAddress = new IPAddress();
                }
                return _hostAddress;
            }
            set
            {
                _hostAddress = value;
                RaisePropertyChanged("HostAddress");
            }
        }

        string _coverageConfiguration;

        public string CoverageConfiguration
        {
            get { return _coverageConfiguration; }
            set
            {
                _coverageConfiguration = value;
                RaisePropertyChanged("CoverageConfiguration");
            }
        }

        string _SelectionAndPrioritizationConfig;

        public string SelectionAndPrioritizationConfig
        {
            get { return _SelectionAndPrioritizationConfig; }
            set
            {
                _SelectionAndPrioritizationConfig = value;
                RaisePropertyChanged("SelectionAndPrioritizationConfig");
            }
        }

        string _allTestCase;

        public string AllTestCases
        {
            get { return _allTestCase; }
            set
            {
                _allTestCase = value;
                RaisePropertyChanged("AllTestCases");
            }
        }

        string _changedFunctions;

        public string ChangedFunctions
        {
            get { return _changedFunctions; }
            set
            {
                _changedFunctions = value;
                RaisePropertyChanged("ChangedFunctions");


            }
        }

        string _testCases;

        public string TestCasesResult
        {
            get { return _testCases; }
            set
            {
                _testCases = value;
                RaisePropertyChanged("TestCasesResult");
            }
        }

        string _outputTestPlan;

        public string OutputTestPlan
        {
            get { return _outputTestPlan; }
            set
            {
                _outputTestPlan = value;
                RaisePropertyChanged("OutputTestPlan");
            }
        }


        PrioritizationCriteria _prioritization;

        public PrioritizationCriteria Prioritization
        {
            get { return _prioritization; }
            set
            {
                _prioritization = value;
                RaisePropertyChanged("Prioritization");
            }
        }

        public IEnumerable<PrioritizationCriteria> PrioritizationCriterias
        {
            get { return Enum.GetValues(typeof(PrioritizationCriteria)).Cast<PrioritizationCriteria>(); }
        }



        SelectionCriteria _criteria;

        public SelectionCriteria Selection
        {
            get { return _criteria; }
            set
            {
                _criteria = value;
                RaisePropertyChanged("Selection");
            }
        }


        public IEnumerable<SelectionCriteria> SelectionCriterias
        {
            get { return Enum.GetValues(typeof(SelectionCriteria)).Cast<SelectionCriteria>(); }
        }

        #endregion
        #region second view

        private string _firstScript;

        public string FirstScript
        {
            get { return _firstScript; }
            set
            {
                _firstScript = value;
                RaisePropertyChanged("FirstScript");
            }
        }

        private string _apkFileName;

        public string ApkFileName
        {
            get { return _apkFileName; }
            set
            {
                _apkFileName = value;
                RaisePropertyChanged("ApkFileName");
            }
        }

        private string _secondScript;

        public string SecondScript
        {
            get { return _secondScript; }
            set
            {
                _secondScript = value;
                RaisePropertyChanged("SecondScript");
            }
        }

        private string _packageName;

        public string PackageName
        {
            get { return _packageName; }
            set
            {
                _packageName = value;
                RaisePropertyChanged("PackageName");
            }
        }
        #endregion

        #region third view

        StopCriteria _selectedStopCriteria;

        public StopCriteria SelectedStopCriteria
        {
            get { return _selectedStopCriteria; }
            set
            {
                _selectedStopCriteria = value;
                RaisePropertyChanged("SelectedStopCriteria");
            }
        }

        public IEnumerable<StopCriteria> StopCriterias
        {
            get { return Enum.GetValues(typeof(StopCriteria)).Cast<StopCriteria>(); }
        }

        int _stopParameter;

        public int StopParameter
        {
            get { return _stopParameter; }
            set { _stopParameter = value; }
        }

        #endregion

        #region Fourth view data

        Dictionary<string, CSVResults> acumulatedInstrumentedList;

        public Dictionary<string, CSVResults> AcumulatedInstrumentedList
        {
            get
            {
                if (acumulatedInstrumentedList == null)
                {
                    AcumulatedInstrumentedList = new Dictionary<string, CSVResults>();
                }
                return acumulatedInstrumentedList;
            }
            set
            {
                acumulatedInstrumentedList = value;
                RaisePropertyChanged("AcumulatedInstrumentedList");
            }
        }
        ObservableCollection<CSVResults> _instrumentedMethodsList;

        public ObservableCollection<CSVResults> InstrumentedMethodsList
        {
            get
            {
                if (_instrumentedMethodsList == null)
                {
                    InstrumentedMethodsList = new ObservableCollection<CSVResults>();
                }
                return _instrumentedMethodsList;
            }
            private set
            {
                _instrumentedMethodsList = value;
                RaisePropertyChanged("InstrumentedMethodsList");


            }
        }



        public void GetCSVData()
        {
            GetInsrumentedMethods();

            // apsolutna putanja
            string path = @"result.Newcsv.csv";
            string[] separated;
            string[] data = File.ReadAllLines(path);
            string resultsHeader = data[0];

            StreamReader sr = File.OpenText(path);

            if (data != null)
            {
                int ID = 0;
                foreach (string s in data)
                {
                    CSVResults item1 = new CSVResults();
                    if (s == data[0]) continue;
                    separated = s.Split(';');

                    item1.TestName = separated[0];
                    item1.AppName = separated[1];
                    int tracelnght;
                    if (int.TryParse(separated[2], out tracelnght))
                    {
                        item1.TraceLength = tracelnght;
                        item1.CumulativeTraceLength = tracelnght;
                    }

                    double coverage;
                    if (Double.TryParse(separated[3], out coverage))
                    {
                        item1.Coverage = coverage;

                    }
                    else
                    {
                        item1.Coverage = -1.0;

                    }

                    int intitem;

                    if (int.TryParse(separated[4], out intitem))
                    {
                        item1.Runtime = intitem;
                    }
                    else
                    {
                        item1.Runtime = -1;
                    }

                    string[] coveredList = separated[5].Split(' ');   //niz stringova 1 5 6 8 18...
                    if (coveredList.ToString() == "")
                    {
                        break;
                    }


                    foreach (string item in coveredList)
                    {
                        item.Trim();
                        int tempInt = 0;
                        if (int.TryParse(item, out tempInt))
                        {
                            if (InstrumentedMethodsRegistrar.ContainsKey(tempInt))
                            {
                                item1.CoveredMethods.Add(InstrumentedMethodsRegistrar[tempInt]);
                            }
                            else 
                            {
                                item1.CoveredMethods.Add(new OldInstrumentedMethod() { ID = tempInt  ,Method = "<unknown>" });
                            }
                        }
                    }

                    string[] NotCoveredList = separated[6].Split(' ');
                    foreach (string item in NotCoveredList)
                    {
                        item.Trim();
                        int tempInt = 0;
                        if (int.TryParse(item, out tempInt))
                        {
                            if (InstrumentedMethodsRegistrar.ContainsKey(tempInt))
                            {
                                item1.NotCoveredMethods.Add(InstrumentedMethodsRegistrar[tempInt]);
                            }
                            else 
                            {
                                item1.NotCoveredMethods.Add(new OldInstrumentedMethod() { ID = tempInt, Method = "<unknown>" });
                            }
                        }
                    }
                    item1.ID = ID;
                    ID++;
                    InstrumentedMethodsList.Add(item1);
                }
            }
        }


        Dictionary<int, OldInstrumentedMethod> _instrumentedMethodsRegistrar;

        public Dictionary<int, OldInstrumentedMethod> InstrumentedMethodsRegistrar
        {
            get
            {
                if (_instrumentedMethodsRegistrar == null)
                {
                    InstrumentedMethodsRegistrar = new Dictionary<int, OldInstrumentedMethod>();
                }
                return _instrumentedMethodsRegistrar;
            }
            set { _instrumentedMethodsRegistrar = value; }
        }



        private void GetInsrumentedMethods()
        {
            //TODO nedostaje jedan broj funkcija u InstrumentedAPK_methods.csv
            string path = @"InstrumentedAPK_methods.csv";
            string[] separated;

            string[] data = File.ReadAllLines(path);
            string instrumentedHeader = data[0];

            foreach (string s in data)
            {
                OldInstrumentedMethod item = new OldInstrumentedMethod();
                if (s == data[0]) continue;
                separated = s.Split(';');
                //Console.WriteLine(s);
                int id;
                if (int.TryParse(separated[0], out id))
                {
                    item.ID = id;
                }
                item.Method = separated[1];
                item.Package = separated[2];
                InstrumentedMethodsRegistrar.Add(item.ID, item);
                //instrumentedMethodsList.Add(item);
            }
        }
        #endregion
    }
}
