﻿
namespace mockupCirene.ViewModel.Instrumentation
{
    using mockupCirene.Helpers;
    using mockupCirene.Model;

    /// <summary>
    /// A class with properties of model and output of test cases.
    /// </summary>
    public class InstrumentationResultViewModel : ObservableObject
    {
        TestCases _model;

        /// <summary>
        /// A constructor for the result view model of instrumentation process.
        /// </summary>
        /// <param name="model"></param>
        public InstrumentationResultViewModel(TestCases model)
        {
            _model = model;            
        }
        
        /// <summary>
        /// Gets and sets the model.
        /// </summary>
        public TestCases Model
        {
            get { return _model; }
            set 
            { 
                _model = value;
                RaisePropertyChanged("Model");
            }
        }

        private string _firstStandardOutput;

        /// <summary>
        /// Gets and sets the first standard output.
        /// </summary>
        public string FirstStandardOutput
        {
            get { return _firstStandardOutput; }
            set
            {
                _firstStandardOutput = value;
                RaisePropertyChanged("FirstStandardOutput");
            }
        }
        private string _firstErrorOuput;

        /// <summary>
        /// Gets and sets the first error output.
        /// </summary>
        public string FirstErrorOuput
        {
            get { return _firstErrorOuput; }
            set
            {
                _firstErrorOuput = value;
                RaisePropertyChanged("FirstErrorOuput");
            }
        }
    }
}
