﻿// -----------------------------------------------------------------------
// <copyright file="InstrumentationViewModel.cs" company=".">
// 
// </copyright>
// -----------------------------------------------------------------------

namespace mockupCirene.ViewModel.Testing
{
    using System.Collections.ObjectModel;
    using mockupCirene.Helpers;
    using mockupCirene.Model;
    using mockupCirene.Model.Components;

    /// <summary>
    /// This class implements the model of the instrumentation process.
    /// </summary>
    public class InstrumentationViewModel : ObservableObject
    {
        /// <summary>
        /// Constructor for the view model of instrumentation process.
        /// </summary>
        /// <param name="model"></param>
        public InstrumentationViewModel(TestCases model)
        {
            Model = model;
        }

        TestCases _model;

        /// <summary>
        /// Gets and sets the model.
        /// </summary>
        public TestCases Model
        {
            get { return _model; }
            set
            {
                _model = value;
                RaisePropertyChanged("Model");
            }
        }

        ObservableCollection<CSVResults> _byTestsMethodsList;

        /// <summary>
        /// Gets and sets tests method list.
        /// </summary>
        public ObservableCollection<CSVResults> ByTestsMethodsList
        {
            get
            {
                if (_byTestsMethodsList == null)
                {
                    ByTestsMethodsList = new ObservableCollection<CSVResults>();
                }
                return _byTestsMethodsList;
            }
            set
            {
                _byTestsMethodsList = value;
                RaisePropertyChanged("ByTestsMethodsList");
            }
        }
    }
}
